DEFINT A-Z
DECLARE FUNCTION Continue% ()
DECLARE FUNCTION ClickedX% ()
DECLARE SUB Font1 (xpos%, ypos%, Colr%, Scal%, Text$, Bold%)
DECLARE FUNCTION GetInput$ (Rpos%, Cpos%, Length%)
DECLARE SUB GetMouse (lb%, rb%, xMouse%, yMouse%)
DECLARE SUB Limits (x1%, y1%, x2%, y2%)
DECLARE SUB LocateCursor (x%, y%)
DECLARE SUB CursorOff ()
DECLARE SUB MouseDriver (ax%, bx%, cx%, dx%)
DECLARE SUB CursorOn ()
DECLARE FUNCTION Initialize% ()
DECLARE SUB Center (y%, Text$)
DECLARE SUB MakePopUp (x1%, y1%, x2%, y2%, Title$)
DECLARE SUB PressX ()
DECLARE SUB PopDown (HowMany%)
DECLARE SUB LoadFont (FontNum%, FileSpec$)
DECLARE SUB UseFont (FontNum%, xpos%, ypos%, Text$, Placement%)

DIM SHARED Font%(12, 94, 17)
DIM SHARED Temp%(17)
DIM SHARED Text$
DIM SHARED CurrentClose%(4, 9)
DIM SHARED x%, y%
DIM SHARED NumOfWins%
DIM SHARED PrevBar%(4, 9)
DIM SHARED GrabItSize%
DIM SHARED MaxWindows%

GrabItSize% = 15522
MaxWindows% = 9

'---------------------------------------------------------------------------
DIM SHARED Mouse$
  Mouse$ = SPACE$(57)
  FOR i% = 1 TO 57
        READ a$
        H$ = CHR$(VAL("&H" + a$))
        MID$(Mouse$, i%, 1) = H$
  NEXT i%
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00
CLS
        ms% = Initialize%
        IF NOT ms% THEN
          PRINT "Mouse not found"
          END
        END IF
'---------------------------------------------------------------------------
LoadFont 1, "font14.fff"
NumOfWins% = 0
'---------------------------------------------------------------------------
SCREEN 12
LINE (0, 0)-(640, 480), 3, BF

FOR i% = 1 TO 150
  LINE (RND * 640, RND * 480)-(RND * 640, RND * 480), RND * 16
NEXT i%

LINE (223, 188)-(402, 217), 7, BF
LINE (223, 188)-(400, 215), 15, BF
LINE (225, 190)-(402, 217), 8, BF
LINE (225, 190)-(400, 215), 7, BF
UseFont 1, 230, 200, "Press any key to quit", 3
UseFont 1, 229, 199, "Press any key to quit", 4

MakePopUp 100, 100, 300, 300, "Sample Window 1"
MakePopUp 140, 140, 340, 340, "Sample Window 2"
MakePopUp 180, 180, 380, 380, "Sample Window 3"

MakePopUp 220, 220, 420, 420, "Sample Window 4"
MakePopUp 260, 260, 460, 460, "Sample Window 5"
MakePopUp 240, 240, 440, 440, "Sample Window 6"

MakePopUp 200, 200, 400, 400, "Sample Window 7"
MakePopUp 160, 160, 360, 360, "Sample Window 8"
MakePopUp 120, 120, 320, 320, "Sample Window 9"

CursorOn

        DO WHILE INKEY$ = ""
 
          GetMouse lb%, rb%, x%, y%
          IF lb% = -1 AND ClickedX% = 1 THEN PressX: PopDown 1: lb% = 0
          IF NumOfWins% = 0 AND lb% = -1 THEN EXIT DO
        LOOP
CLEAR
DEF SEG
KILL "*.$u$"
SCREEN 0
WIDTH 80
END
'------------------
ErrTrap:
PRINT ERR
END

SUB Center (y%, Text$)
'
'   Centers standard text on a 80 character screen.
'
'
        D% = 40 - INT(LEN(Text$) / 2)
        LOCATE y%, D%, 0: PRINT Text$
END SUB

FUNCTION ClickedX%

IF x% >= CurrentClose%(1, NumOfWins%) AND x% <= CurrentClose%(3, NumOfWins%) AND y% <= CurrentClose%(2, NumOfWins%) AND y% >= CurrentClose%(4, NumOfWins%) THEN
  ClickedX% = 1
  ELSE ClickedX% = 0
END IF

END FUNCTION

DEFSNG A-Z
SUB CursorOff
 '
 '        Turns OFF the display of the mouse cursor.
 '
 ax% = 2
 MouseDriver ax%, 0, 0, 0
END SUB

SUB CursorOn
 '
 '        Turns ON the display of the mouse cursor.
 '
  ax% = 1
  MouseDriver ax%, 0, 0, 0
END SUB

DEFINT A-Z
SUB Font1 (xpos%, ypos%, Colr%, Scal%, Text$, Bold%)
'
'  Proprietary Draw-Font routine by UWLabs(c)1996.
'
'  This routine will "quickly" draw text on any color background.
'     Speed is dependent upon processor AND video response.
'  "Xpos%" is the beginning x-coordinate.
'  "Ypos%" is the beginning y-coordinate.
'  "Colr%" is the color of the text to be drawn.
'  "Scal%" is the scale to draw the text at. (Odd numbers can sometimes
'     produce mixed results).
'  "Text$" is the desired text string.
'  "Bold%" is the flag for whether to display it as bold.
'     Bold% = 1 will display text as BOLD.
'     Bold% = 0 will display regular text.
'
'
        'create scale and color string:  (like this  "c0s2")
        DD$ = "c" + LTRIM$(STR$(Colr%)) + " s" + LTRIM$(STR$(Scal%))
        DRAW DD$                                'DRAW scale and color.
        Shift% = (Scal% * 4)                    'Calculate character spacing.
        NewX% = xpos%                           'Save original X-coordinate.
           FOR StrngLen% = 1 TO LEN(Text$)      'FOR all the string's length.
                BakClr% = POINT(NewX%, ypos%)   'Find current backgrnd color,
                PSET (NewX%, ypos%), BakClr%    'and start in THAT color.
                DRAW DD$                        'Reset scale and color.
                char% = ASC(MID$(Text$, StrngLen%, 1))    'Find CHARacter.
                GOSUB PickChar                            'SUB to draw it.
                IF Bold% = 1 THEN                         'Repeat the process
                        NewX% = NewX% + 1                 'if the BOLD is
                        BakClr% = POINT(NewX%, ypos%)     'flagged, but add
                        PSET (NewX%, ypos%), BakClr%      'one more pixel to
                        DRAW DD$                          'x-coordinate.
                        char = ASC(MID$(Text$, StrngLen%, 1))
                        GOSUB PickChar
                END IF
                NewX% = NewX% + Shift%          'Add in the character width.
           NEXT StrngLen%
DRAW "s4"                                       'reset drawing scale
EXIT SUB                                        'DONE.
'-----------------
PickChar:                       'Select EACH character and DRAW it...
SELECT CASE char%               '(char% is the ASCII character code.)
'
'ASCIIcode     DRAWstring                                        CharacterName
'------------------------------------------------------------------------------
CASE 32: DRAW ""                                                          'Spc
CASE 33: DRAW "bu12br4br2d4d2bd4d2bl4bl2"                                 ' !
CASE 34: DRAW "bu12br4d2u2br4d2u2bd12bl8"                                 ' "
CASE 35: DRAW "bu12br2d8u8br4d8u8d2r2l8bd4r8bd4bd2bl8"                    ' #
CASE 36: DRAW "bu12br12bd2l2l8g2f2r8f2g2l8l2bd2br4u12br4d12"              ' $
CASE 37: DRAW "bu12bd2f2r2e2h2l2g2bu2br12g12br12bl2e2h2l2g2f2r2br2bl12"   ' %
CASE 38: DRAW "br12bl2bu2u2d2g2l4l2h2u2e2r2e2u2h2l2g2f8f2br2bl12"         ' &
CASE 39: DRAW "bu12 br4br2d2g2bg4bd4"                                     ' '
CASE 40: DRAW "br8h4u4e4bd12bl8"                                          ' (
CASE 41: DRAW "br4e4u4h4bl4bd12"                                          ' )
CASE 42: DRAW " bu12br2f4u4d4e4g8e4d4u4f4h4l4r8"                          ' *
CASE 43: DRAW "bu4bu2br2r8l4u4d8bd2bl2bl4"                                ' +
CASE 44: DRAW "br4br2bu2d2g2e2bl2bl4"                                     ' ,
CASE 45: DRAW "bu4bu2br2r8bd2bd4bl8bl2"                                   ' -
CASE 46: DRAW "br4br2u2d2bl2bl4"                                          ' .
CASE 47: DRAW "e12g12"                                                    ' /
CASE 48: DRAW "bu2 f2r8e2u8h2l8g2d8br2e8be2bd12bl12"                      ' 0
CASE 49: DRAW "bu12br4r2d12r2l4bl4"                                       ' 1
CASE 50: DRAW "bu8bu2e2r8f2d2g2l8g2d4r12"                                 ' 2
CASE 51: DRAW "bu8bu2e2r8f2d2g2l4r4f2d2g2l8h2bd2"                         ' 3
CASE 52: DRAW "bu12br8g8r12bl4u8d12bl8"                                   ' 4
CASE 53: DRAW "bu12br12l12d4d2e2r8f2d4g2l8h2"                             ' 5
CASE 54: DRAW "bu12br12bd2h2l8g2d8f2r8e2u2h2l8g2bd4bd2"                   ' 6
CASE 55: DRAW "bu12r12d2g4g2d4bl4bl2"                                     ' 7
CASE 56: DRAW "bu2f2r8e2u2h2l8h2u2e2r8f2d2g2l8g2d2bd2"                    ' 8
CASE 57: DRAW "bu2f2r8e2u8h2l8g2d2f2r8e2bl12bd8"                          ' 9
CASE 58: DRAW "bu12br2br4 bd2d2bd4d2bd2bl2bl4"                            ' :
CASE 59: DRAW "bu12br4br2bd2d2bd4d2g2bl4"                                 ' ;
CASE 60: DRAW "bu4bu2br2e4e2g2g4f2f4bl8"                                  ' <
CASE 61: DRAW "bu4br2r8bu4l8bl2bd4bd4"                                    ' =
CASE 62: DRAW "bu12br4f2f4g2g4bl4"                                        ' >
CASE 63: DRAW "bu8bu2br2e2r4f2d2g2l2d2bd4udbl4bl2"                        ' ?
CASE 64: DRAW "br12l8l2h2u8e2r8f2d4d2u2g2l4h2e2r4f2bd4bd2bl12"            ' @
CASE 65: DRAW "u8e4r4f4d8u4l12d4"                                         ' A
CASE 66: DRAW "u12r8r2f2d2g2l8l2r8r2f2d2g2l8l2"                           ' B
CASE 67: DRAW "bu12br12bd2h2l8g2d8f2r8e2g2bl8bl2"                         ' C
CASE 68: DRAW "u12r8f4d4g4l8"                                             ' D
CASE 69: DRAW "u12r12l12d4d2r8l8d4d2r12bl12"                              ' E
CASE 70: DRAW "u12r12l12d4d2r8l8d4d2"                                     ' F
CASE 71: DRAW "bu2u8e2r8f2bd4bd2l4r4d4u2g2l8h2bd2"                        ' G
CASE 72: DRAW "u12d4d2r12u2u4d12bl12"                                     ' H
CASE 73: DRAW "r12bu12l12r4r2d12l4l2"                                     ' I
CASE 74: DRAW "bu12br4r8l4d8d2g2l4h2"                                     ' J
CASE 75: DRAW "u12d8m+12,-8bd12h4h3br3bd7bl8"                             ' K
CASE 76: DRAW "u12d12r12l12"                                              ' L
CASE 77: DRAW "u12f4f2e4e2d12bl12"                                        ' M
CASE 78: DRAW "u12f12u12bd12bl12"                                         ' N
CASE 79: DRAW "bu4u4e4r4f4d4g4l4h4bd4"                                    ' O
CASE 80: DRAW "u12r8r2f2d2g2l8l2d4d2"                                     ' P
CASE 81: DRAW "bu4u4e4r4f4d4g4l4h4br8f4bl12"                              ' Q
CASE 82: DRAW "u12r8r2f2d2g2l8l2r4r2f4f2bl12"                             ' R
CASE 83: DRAW "bu2f2r8e2u2h2l8h2u2e2r8f2"                                 ' S
CASE 84: DRAW "bu12r12l4l2d12bl2bl4"                                      ' T
CASE 85: DRAW "bu2u8u2d2d8f2r8e2u2u8bd12bl12"                             ' U
CASE 86: DRAW "br4br2h4h2u2u4br12d4d2g4g2bl4bl2"                          ' V
CASE 87: DRAW "bu12d8d2f2r2e2u4d4f2r2e2u8u2bd12bl12"                      ' W
CASE 88: DRAW "bu12f12bu12g12"                                            ' X
CASE 89: DRAW "bu12f4f2e4e2g2g4d4d2bl4bl2"                                ' Y
CASE 90: DRAW "bu12r12g12r12l12"                                          ' Z
CASE 91: DRAW "bu12br4r4l4d12r4bl8"                                       ' [
CASE 92: DRAW "bu12f12bl12"                                               ' \
CASE 93: DRAW "bu12br4r4d12l4bl4"                                         ' ]
CASE 94: DRAW "bu12bd4br2e4f4br2bd8bl12"                                  ' ^
CASE 95: DRAW "r12l12"                                                    ' _
CASE 96: DRAW "bu12br4d2f2h2u2bl4bd12"                                    ' '
CASE 97: DRAW "bu8br2r8f2d4d2u2g2l8h2e2r8f2"                              ' a
CASE 98: DRAW "u12d4d2e2r8f2d4g2l8h2"                                     ' b
CASE 99: DRAW "bu2u4e2r8f2bd4g2l8h2bd2"                                   ' c
CASE 100: DRAW "bu12br12d12u4u2h2l8g2d4f2r8e2bd2bl12"                     ' d
CASE 101: DRAW "br12bu4u2h2l8g2d2r12l12d2f2r8"                            ' e
CASE 102: DRAW "br12bu8bu2h2l2g2d8d2u4u2l2r4bd2bd4bl8"                    ' f
CASE 103: DRAW "br12u2g2l8h2u4e2r8f2u2d8d2g2l8bu4bl2"                     ' g
CASE 104: DRAW "u12d4d2e2r8f2d4d2bd12"                                    ' h
CASE 105: DRAW "bu8bu4br4r2bd4l2r2d8r2l4bl4"                              ' i
CASE 106: DRAW "bu8bu4br4r2bd4l2r2d8d2g2l2bh2bu2"                         ' j
CASE 107: DRAW "u12d8r4r2e4g4f4bl8bl2"                                    ' k
CASE 108: DRAW "bu12br4r2d12r2l4bl4"                                      ' l
CASE 109: DRAW "u8d2e2r2f2d4d2u2u4e2r2f2d2d4bl12"                         ' m
CASE 110: DRAW "u8d2e2r8f2d4d2bl12"                                       ' n
CASE 111: DRAW "bu2u4e2r8f2d4g2l8h2bd2"                                   ' o
CASE 112: DRAW "d4u12d2e2r8f2d4g2l8h2"                                    ' p
CASE 113: DRAW "br12d4r2l2u12d2h2l8g2d4f2r8e2g2l8bl2"                     ' q
CASE 114: DRAW "u8d2e2r8bd8bl8bl2"                                        ' r
CASE 115: DRAW "r2r8e2h2l8h2e2r8br2bd8bl12"                               ' s
CASE 116: DRAW "bu12br4br2d4l2r4l2d4d2f2r2bl8bl2"                         ' t
CASE 117: DRAW "bu2u2u4d4d2f2r8e2u2u4d8bl12"                              ' u
CASE 118: DRAW "bu8d2f4f2e2e4u2bd8bl12"                                   ' v
CASE 119: DRAW "bu8d4d2f2r2e2u4d4f2r2e2u4u2bd8bl12"                       ' w
CASE 120: DRAW "bu8r2f8r2bu8l2g8l2"                                       ' x
CASE 121: DRAW "bu8d4f4r4r2e2u2u4d8g4l4l2bl2bu4"                          ' y
CASE 122: DRAW "bu8r12m-12,+8r12l12"                                      ' z
CASE 123: DRAW "bu12 br4r2f2d2f2g2d2g2l2bl4"                              ' }
CASE 124: DRAW "bu12br4br2d4bd4d4bl2bl4"                                  ' |
CASE 125: DRAW "bu12br4br4l2g2d2g2f2d2f2r2l2bl4bl2"                       ' {
CASE 126: DRAW "bu8bu2e2r2f2r4e2bu12bl12"                                 ' ~

END SELECT

RETURN
'-------------
END SUB

FUNCTION GetInput$ (Rpos%, Cpos%, Length%)
'
' Function to replace the INPUT statement.
'  Locates and determines the length of the required input also.
' Syntax:
'               Text$ = GetInput$(Rpos%, Cpos%, Length%)
' Where:
'  Text$ = is the string returned. ""(nul) if [Esc] is pressed.
'  Rpos% = Row position typing begins.
'  Cpos% = Column position typing begins.
'  Length% = The number of characters to be entered. (Maximum 79 characters).
'
'
  col = Cpos%
  row = Rpos%

LOCATE row, col, 1, 0, 31
InsertMode = 0
                      
     DO
        T$ = INKEY$
        IF T$ = CHR$(13) THEN EXIT DO
         IF T$ = CHR$(27) THEN
              Text$ = "": EXIT DO
         END IF
        IF T$ <> "" THEN GOSUB CheckKeys
     LOOP

GOTO NearTheBottom
'- - - - - - - - - - - - - - -  - - - - - -
CheckKeys:
   SELECT CASE T$
        CASE CHR$(8)
                IF col >= Cpos% + LEN(Text$) THEN
                  IF LEN(Text$) = 1 THEN
                     Text$ = "": col = Cpos%
                     GOTO SelEnd
                  END IF
                  IF col = Cpos% THEN RETURN
                  Text$ = LEFT$(Text$, (LEN(Text$) - 1))
                  col = col - 1
                END IF
                IF col < Cpos% + LEN(Text$) THEN
                  IF col = Cpos% THEN RETURN
                  LText$ = LEFT$(Text$, (col - Cpos%) - 1)
                  RText$ = RIGHT$(Text$, (LEN(Text$) + Cpos%) - col)
                  Text$ = LText$ + RText$
                  col = col - 1
                END IF
        CASE CHR$(9)
                BEEP: RETURN
        CASE CHR$(0) + CHR$(82)
                IF InsertMode = 1 THEN InsertMode = 0: GOTO SelEnd
                IF InsertMode = 0 THEN InsertMode = 1: GOTO SelEnd
        CASE CHR$(0) + CHR$(71)
                FOR q = 1 TO Length%
                    FirstLtr = INSTR(q, Text$, " ")
                    IF FirstLtr <> q THEN EXIT FOR
                    StartPos = FirstLtr
                NEXT
                col = StartPos + Cpos%
        CASE CHR$(0) + CHR$(83)
                IF col >= Cpos% + LEN(Text$) THEN RETURN
                IF col = Cpos% THEN
                    Text$ = RIGHT$(Text$, LEN(Text$) - 1)
                    GOTO SelEnd
                END IF
                LText$ = LEFT$(Text$, (col - Cpos%))
                RText$ = RIGHT$(Text$, (LEN(Text$) + Cpos%) - col - 1)
                Text$ = LText$ + RText$
                IF LEN(Text$) > Length% THEN Text$ = LEFT$(Text$, Length%)
        CASE CHR$(0) + CHR$(79)
                col = Cpos% + LEN(Text$)
        CASE CHR$(0) + CHR$(75)
                IF col > Cpos% THEN col = col - 1
        CASE CHR$(0) + CHR$(77)
                IF col < Cpos% + Length% THEN col = col + 1
        CASE ELSE
           IF LEN(T$) > 1 THEN BEEP: RETURN
           IF col >= Cpos% + LEN(Text$) THEN
                col = col + 1
                IF col > Cpos% + Length% THEN col = col - 1: RETURN
                Text$ = Text$ + T$
           END IF
           IF col < Cpos% + LEN(Text$) THEN
                IF InsertMode = 1 THEN
                     LText$ = LEFT$(Text$, (col - Cpos%))
                     RText$ = RIGHT$(Text$, (LEN(Text$) + Cpos%) - col)
                     Text$ = LText$ + T$ + RText$
                     IF LEN(Text$) > Length% THEN Text$ = LEFT$(Text$, Length%)
                     col = col + 1
                END IF
                IF InsertMode = 0 THEN
                     LText$ = LEFT$(Text$, (col - Cpos%))
                     RText$ = RIGHT$(Text$, (LEN(Text$) + Cpos%) - col - 1)
                     Text$ = LText$ + T$ + RText$
                     IF LEN(Text$) > Length% THEN Text$ = LEFT$(Text$, Length%)
                     col = col + 1
                END IF
           END IF
   END SELECT
SelEnd:
   x = Length% - LEN(Text$)
        IF x < 0 THEN x = 0
   LOCATE Rpos%, Cpos%, 0: PRINT Text$; STRING$(x, " ")
        IF InsertMode = 0 THEN LOCATE row, col, 1, 0, 31
        IF InsertMode = 1 THEN LOCATE row, col, 1, 29, 31
RETURN
'----------------------------------------------------------
NearTheBottom:
GetInput$ = Text$
END FUNCTION

DEFSNG A-Z
SUB GetMouse (lb%, rb%, xMouse%, yMouse%)
  ax% = 3
  MouseDriver ax%, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  rb% = ((bx% AND 2) <> 0)
 
  'xMouse% = (cx% / 2) + 1
 
  'yMouse% = (dx% / 8) + 1
  xMouse% = cx% + 1
  yMouse% = dx% + 1
END SUB

FUNCTION Initialize%
  ax% = 0
  MouseDriver ax%, 0, 0, 0
  Initialize% = ax%
END FUNCTION

SUB Limits (x1%, y1%, x2%, y2%)
  ax% = 7
  cx% = (x1% - 1) * 8
  dx% = (x2% - 1) * 8
  MouseDriver ax%, 0, cx%, dx%
  ax% = 8
  cx% = (y1% - 1) * 8
  dx% = (y2% - 1) * 8
  MouseDriver ax%, 0, cx%, dx%
END SUB

DEFINT A-Z
SUB LoadFont (FontNum%, FileSpec$)

OPEN FileSpec$ FOR INPUT AS #1

FOR x% = 0 TO 94
      FOR y% = 0 TO 17
        INPUT #1, Font%(FontNum%, x%, y%)
      NEXT y%
NEXT x%

CLOSE #1


END SUB

DEFSNG A-Z
SUB LocateCursor (x%, y%)
  ax% = 4
  cx% = (x% - 1) * 8
  dx% = (y% - 1) * 8
  MouseDriver ax%, 0, cx%, dx%
END SUB

DEFINT A-Z
SUB MakePopUp (x1%, y1%, x2%, y2%, Title$)

IF PrevBar%(3, NumOfWins%) - PrevBar%(1, NumOfWins%) < 1 THEN GOTO SkipBar
BarSize& = 4 + INT(((PrevBar%(3, NumOfWins%) - PrevBar%(1, NumOfWins%) + 1 + 7) / 8) * 4 * (PrevBar%(4, NumOfWins%) - PrevBar%(2, NumOfWins%) + 1))
DIM Bar%(BarSize&)
GET (PrevBar%(1, NumOfWins%), PrevBar%(2, NumOfWins%))-(PrevBar%(3, NumOfWins%), PrevBar%(4, NumOfWins%)), Bar%
LINE (PrevBar%(1, NumOfWins%), PrevBar%(2, NumOfWins%))-(PrevBar%(3, NumOfWins%), PrevBar%(4, NumOfWins%)), 8, BF
LINE (CurrentClose%(1, NumOfWins%), CurrentClose%(2, NumOfWins%))-(CurrentClose%(3, NumOfWins%), CurrentClose%(4, NumOfWins%)), 15, BF
PUT (PrevBar%(1, NumOfWins%), PrevBar%(2, NumOfWins%)), Bar%, XOR

SkipBar:
NumOfWins% = NumOfWins% + 1


IF NumOfWins% > MaxWindows% THEN
  BEEP: END
END IF

CurrentClose%(1, NumOfWins%) = x2% - 15
CurrentClose%(2, NumOfWins%) = y1% + 14
CurrentClose%(3, NumOfWins%) = x2% - 4
CurrentClose%(4, NumOfWins%) = y1% + 4

FOR a% = 0 TO 478 STEP 96
   TmpFile$ = LTRIM$(RTRIM$(STR$(NumOfWins%))) + "UWL"
   Cntr% = Cntr% + 1
   TmpFile$ = TmpFile$ + LTRIM$(RTRIM$(STR$(Cntr%))) + ".$U$"
   IF a% = 384 THEN a% = 383
   REDIM Tmp%(0 TO GrabItSize%)
   DEF SEG = VARSEG(Tmp%(0))
   GET (0, a%)-(639, a% + 96), Tmp%
   BSAVE TmpFile$, VARPTR(Tmp%(0)), 62088
   DEF SEG
 NEXT a%
 Cntr% = 0
 REDIM Tmp%(0)
FOR i% = y1% + 5 TO y2% STEP 2
    LINE (x2%, i%)-(x2% + 5, i%), 0, , &HAAAA
    LINE (x2% - 1, i% + 1)-(x2% + 5, i% + 1), 0, , &HAAAA
NEXT i%
FOR i% = y2% TO y2% + 5 STEP 2
    LINE (x1% + 5, i%)-(x2% + 5, i%), 0, , &HAAAA
    LINE (x1% + 4, i% + 1)-(x2% + 5, i% + 1), 0, , &HAAAA
NEXT i%

LINE (x1%, y1%)-(x2%, y2%), 7, BF

PSET (x1%, y1%), 15
LINE -(x2%, y1%), 15
LINE -(x2%, y2%), 8
LINE -(x1, y2%), 8
LINE -(x1%, y1%), 15

PSET (x2%, y1%), 7
PSET (x1%, y2%), 7
PSET (x2%, y2%), 8

LINE (x1% + 3, y1% + 3)-(x2% - 3, y1% + 15), 1, BF
PrevBar%(1, NumOfWins%) = x1% + 3
PrevBar%(2, NumOfWins%) = y1% + 3
PrevBar%(3, NumOfWins%) = x2% - 3
PrevBar%(4, NumOfWins%) = y1% + 15

'Font1 x1% + 5, y1% + 11, 15, 2, Title$, 1
UseFont 1, x1% + 5, y1% + 6, Title$, 3

PSET (x1% + 4, y1% + 18), 8
LINE -(x2% - 4, y1% + 18), 8
LINE -(x2% - 4, y2% - 4), 15
LINE -(x1 + 4, y2% - 4), 15
LINE -(x1% + 4, y1% + 18), 8

LINE (x2% - 15, y1% + 14)-(x2% - 4, y1% + 4), 7, BF

LINE (x2% - 15, y1% + 4)-(x2% - 5, y1% + 4), 15
LINE (x2% - 4, y1% + 5)-(x2% - 4, y1% + 13), 8
LINE (x2% - 4, y1% + 14)-(x2% - 14, y1% + 14), 8
LINE (x2% - 15, y1% + 4)-(x2% - 15, y1% + 13), 15

LINE (x2% - 12, y1% + 12)-(x2% - 6, y1% + 6), 0
LINE (x2% - 13, y1% + 12)-(x2% - 7, y1% + 6), 0
LINE (x2% - 12, y1% + 6)-(x2% - 6, y1% + 12), 0
LINE (x2% - 13, y1% + 6)-(x2% - 7, y1% + 12), 0

END SUB

DEFSNG A-Z
SUB MouseDriver (ax%, bx%, cx%, dx%)
  DEF SEG = VARSEG(Mouse$)
  Mouse% = SADD(Mouse$)
  CALL Absolute(ax%, bx%, cx%, dx%, Mouse%)
END SUB

DEFINT A-Z
SUB PopDown (HowMany%)
'
'  HowMany% =
'              0  - ALL
'              1  - Current
'
'

IF HowMany% = 0 THEN
    Cntr% = 0
    CursorOff
    FOR a% = 0 TO 477 STEP 96
        Cntr% = Cntr% + 1
        TmpFile$ = "1UWL" + LTRIM$(RTRIM$(STR$(Cntr%))) + ".$U$"
        REDIM Tmp%(0 TO GrabItSize%)
        DEF SEG = VARSEG(Tmp%(0))
        BLOAD TmpFile$, VARPTR(Tmp%(0))
        DEF SEG
        IF a% > 383 THEN a% = 383
        PUT (0, a%), Tmp%
    NEXT a%
    CursorOn
    EXIT SUB
END IF
    Cntr% = 0
    CursorOff
    FOR a% = 0 TO 477 STEP 96
        Cntr% = Cntr% + 1
        TmpFile$ = LTRIM$(RTRIM$(STR$(NumOfWins%))) + "UWL" + LTRIM$(RTRIM$(STR$(Cntr%))) + ".$U$"
        REDIM Tmp%(1 TO GrabItSize%)
        DEF SEG = VARSEG(Tmp%(1))
        BLOAD TmpFile$, VARPTR(Tmp%(1))
        DEF SEG
        IF a% > 383 THEN a% = 383
        PUT (0, a%), Tmp%, PSET
    NEXT a%
    NumOfWins% = NumOfWins% - 1

BarSize& = 4 + INT(((PrevBar%(3, NumOfWins%) - PrevBar%(1, NumOfWins%) + 1 + 7) / 8) * 4 * (PrevBar%(4, NumOfWins%) - PrevBar%(2, NumOfWins%) + 1))
DIM Bar%(BarSize&)
GET (PrevBar%(1, NumOfWins%), PrevBar%(2, NumOfWins%))-(PrevBar%(3, NumOfWins%), PrevBar%(4, NumOfWins%)), Bar%
LINE (PrevBar%(1, NumOfWins%), PrevBar%(2, NumOfWins%))-(PrevBar%(3, NumOfWins%), PrevBar%(4, NumOfWins%)), 8, BF
LINE (CurrentClose%(1, NumOfWins%), CurrentClose%(2, NumOfWins%))-(CurrentClose%(3, NumOfWins%), CurrentClose%(4, NumOfWins%)), 15, BF
PUT (PrevBar%(1, NumOfWins%), PrevBar%(2, NumOfWins%)), Bar%, XOR
   
    CursorOn
REDIM Tmp%(0)
END SUB

SUB PressX
CursorOff
DIM T%(100)
GET (CurrentClose%(1, NumOfWins%), CurrentClose%(4, NumOfWins%))-(CurrentClose%(3, NumOfWins%), CurrentClose%(2, NumOfWins%)), T%
LINE (CurrentClose%(1, NumOfWins%), CurrentClose%(4, NumOfWins%))-(CurrentClose%(3, NumOfWins%), CurrentClose%(2, NumOfWins%)), 0, BF
LINE (CurrentClose%(1, NumOfWins%) + 1, CurrentClose%(4, NumOfWins%) + 1)-(CurrentClose%(3, NumOfWins%) - 1, CurrentClose%(2, NumOfWins%) - 1), 7, BF
PUT (CurrentClose%(1, NumOfWins%) + 1, CurrentClose%(4, NumOfWins%)), T%, PSET

LINE (CurrentClose%(1, NumOfWins%), CurrentClose%(4, NumOfWins%))-(CurrentClose%(3, NumOfWins%) + 1, CurrentClose%(2, NumOfWins%)), 0, B
LINE (CurrentClose%(1, NumOfWins%) + 1, CurrentClose%(2, NumOfWins%) - 1)-(CurrentClose%(1, NumOfWins%) + 1, CurrentClose%(4, NumOfWins%) + 1), 15
LINE (CurrentClose%(1, NumOfWins%) + 1, CurrentClose%(4, NumOfWins%) + 1)-(CurrentClose%(3, NumOfWins%) - 0, CurrentClose%(4, NumOfWins%) + 1), 15
CursorOn
lb% = -1
DO WHILE lb% = -1
  GetMouse lb%, rb%, x%, y%
LOOP
CursorOff
LINE (CurrentClose%(1, NumOfWins%), CurrentClose%(4, NumOfWins%))-(CurrentClose%(3, NumOfWins%) + 1, CurrentClose%(2, NumOfWins%)), 1, BF
PUT (CurrentClose%(1, NumOfWins%), CurrentClose%(4, NumOfWins%)), T%, PSET
CursorOn

END SUB

SUB UseFont (FontNum%, xpos%, ypos%, Text$, Placement%)

        FOR x% = 1 TO LEN(Text$)
                D% = ASC(MID$(Text$, x%, 1)) - 32
                 c% = 0
                 FOR y% = D% TO D% + 17
                         Temp%(c%) = Font%(FontNum%, D%, c%)
                         c% = c% + 1
                 NEXT y%
                 IF Placement% = 1 THEN PUT (xpos% + (x% * 8) - 8, ypos%), Temp%, PSET
                 IF Placement% = 2 THEN PUT (xpos% + (x% * 8) - 8, ypos%), Temp%, PRESET
                 IF Placement% = 3 THEN PUT (xpos% + (x% * 8) - 8, ypos%), Temp%, OR
                 IF Placement% = 4 THEN PUT (xpos% + (x% * 8) - 8, ypos%), Temp%, XOR
                 IF Placement% = 5 THEN PUT (xpos% + (x% * 8) - 8, ypos%), Temp%, AND
        NEXT x%

END SUB

